package cn.com.tenlion.systembase.service.publicvideo;

import cn.com.tenlion.systembase.pojo.bos.publicvideo.PublicVideoBO;
import cn.com.tenlion.systembase.pojo.dtos.publicvideo.PublicVideoDTO;
import cn.com.tenlion.systembase.pojo.pos.publicvideo.PublicVideoPO;
import cn.com.tenlion.systembase.pojo.vos.publicvideo.PublicVideoVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IPublicVideoService
 * @Description: 城乡社区公共安全视频监控
 * @Author: CodeFactory
 * @Date: 2021-10-13 16:53:02
 * @Version: 3.0
 **/
public interface IPublicVideoService {

    /**
     * 新增城乡社区公共安全视频监控
     *
     * @param publicVideoVO
     * @return
     */
    void save(PublicVideoVO publicVideoVO);

    /**
     * 新增城乡社区公共安全视频监控
     *
     * @param token
     * @param publicVideoVO
     * @return
     */
    void save(String token, PublicVideoVO publicVideoVO);

    /**
     * 新增城乡社区公共安全视频监控
     *
     * @param publicVideoVO
     * @return publicVideoId
     */
    String saveReturnId(PublicVideoVO publicVideoVO);

    /**
     * 新增城乡社区公共安全视频监控
     *
     * @param token
     * @param publicVideoVO
     * @return publicVideoId
     */
    String saveReturnId(String token, PublicVideoVO publicVideoVO);

    /**
     * 删除城乡社区公共安全视频监控
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除城乡社区公共安全视频监控
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除城乡社区公共安全视频监控（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改城乡社区公共安全视频监控
     *
     * @param publicVideoId
     * @param publicVideoVO
     * @return
     */
    void update(String publicVideoId, PublicVideoVO publicVideoVO);

    /**
     * 修改城乡社区公共安全视频监控
     *
     * @param token
     * @param publicVideoId
     * @param publicVideoVO
     * @return
     */
    void update(String token, String publicVideoId, PublicVideoVO publicVideoVO);

    /**
     * 城乡社区公共安全视频监控详情
     *
     * @param params 参数Map
     * @return
     */
    PublicVideoDTO get(Map<String, Object> params);

    /**
     * 城乡社区公共安全视频监控详情
     *
     * @param publicVideoId
     * @return
     */
    PublicVideoDTO get(String publicVideoId);

    /**
     * 城乡社区公共安全视频监控详情
     *
     * @param params 参数Map
     * @return
     */
    PublicVideoBO getBO(Map<String, Object> params);

    /**
     * 城乡社区公共安全视频监控详情
     *
     * @param publicVideoId
     * @return
     */
    PublicVideoBO getBO(String publicVideoId);

    /**
     * 城乡社区公共安全视频监控详情
     *
     * @param params 参数Map
     * @return
     */
    PublicVideoPO getPO(Map<String, Object> params);

    /**
     * 城乡社区公共安全视频监控详情
     *
     * @param publicVideoId
     * @return
     */
    PublicVideoPO getPO(String publicVideoId);

    /**
     * 城乡社区公共安全视频监控列表
     *
     * @param params
     * @return
     */
    List<PublicVideoDTO> list(Map<String, Object> params);

    /**
     * 城乡社区公共安全视频监控列表
     *
     * @param params
     * @return
     */
    List<PublicVideoBO> listBO(Map<String, Object> params);

    /**
     * 城乡社区公共安全视频监控列表
     *
     * @param params
     * @return
     */
    List<PublicVideoPO> listPO(Map<String, Object> params);

    /**
     * 城乡社区公共安全视频监控分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<PublicVideoDTO>> listPage(ListPage page);

    /**
     * 城乡社区公共安全视频监控统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

}